
var path = require("path");
var express = require('express');
var bodyParser = require('body-parser');
var ext = require("./common/ext");
var cookieParser = require('cookie-parser');
var session = require("express-session");


var server = express(),logger;
var config = require("../config.json");

server.use(cookieParser());
server.use(session({
  secret: 'keyboard cat',
  resave: false,
  saveUninitialized: true
}));


server.use(bodyParser.urlencoded({extended: false}));
server.use(bodyParser.json());


function copy_config(a,b){
    if(b.push){
        b.forEach(function(item){
            a.push(item);
        });
    }else{
        for(var key in b){
            if(typeof b[key]=="object" && typeof a[key]=="object"){
                copy_config(a[key],b[key]);
            }else{
                a[key] = b[key];
            }
        }
    }    
}

module.exports = function(config_){

    //console.dir(config);

    //console.dir(config_);

    copy_config(config,config_);

    logger = require("./platform/platform-logger").getLog(path.join(config.root_dir,".."),"server");

    logger.setLevel('debug');


    /*
        platform loader
    */
    var platform_loader = require("./platform/platform-loader")({
        server:server,
        config:config,
        logger:logger
    });

    /*
        start server
    */
    function start(){
        if(config.development){
            server.use("/h5x-lib",express.static(path.join(__dirname,"..","web")));
        }

        if(config.static_dir){
            config.static_dir.forEach(function(static_path){
                //console.log(static_path);
                server.use(static_path,express.static(path.join(config.root_dir,static_path)));
            });
        }

        require("./common/api-upload").route(server);

        server.listen(config.port);
        logger.info("server listen on "+config.port);    
    }


    return {
        load_app : platform_loader.load,
        start : start
    };
}


